From 0f1ac8b3fd900c624621b7ea99ad4a2058afc48e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 12 2020 23:50:45 +0000
Subject: [PATCH 1709/2232] Merge pull request #572 from dtolnay/box


Fix uninitialized Drop on exception in rust::Box<T>::in_place
---

diff --git a/include/cxx.h b/include/cxx.h
index 9ba49a1..34b8771 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -621,10 +621,7 @@ T &Box<T>::operator*() noexcept {
 template <typename T>
 template <typename... Fields>
 Box<T> Box<T>::in_place(Fields &&... fields) {
-  Box box = uninit{};
-  box.ptr = alloc();
-  ::new (box.ptr) T{std::forward<Fields>(fields)...};
-  return box;
+  return from_raw(::new (alloc()) T{std::forward<Fields>(fields)...});
 }
 
 template <typename T>

